# Willow

![Logo](assets/logo.svg)

Ready-to-use components for interactive web applications + framework agnostic integration

[![Unit Tests](https://github.com/ba-st/Willow/actions/workflows/unit-tests.yml/badge.svg)](https://github.com/ba-st/Willow/actions/workflows/unit-tests.yml/badge.svg)
[![Coverage Status](https://codecov.io/github/ba-st/Willow/coverage.svg?branch=release-candidate)](https://codecov.io/gh/ba-st/Willow/branch/release-candidate)
[![Baseline Groups](https://github.com/ba-st/Willow/actions/workflows/loading-groups.yml/badge.svg)](https://github.com/ba-st/Willow/actions/workflows/loading-groups.yml)
[![Markdown Lint](https://github.com/ba-st/Willow/actions/workflows/markdown-lint.yml/badge.svg)](https://github.com/ba-st/Willow/actions/workflows/markdown-lint.yml)

[![GitHub release](https://img.shields.io/github/release/ba-st/Willow.svg)](https://github.com/ba-st/Willow/releases/latest)
[![Pharo 8.0](https://img.shields.io/badge/Pharo-8.0-informational)](https://pharo.org)
[![Pharo 9.0](https://img.shields.io/badge/Pharo-9.0-informational)](https://pharo.org)
[![Pharo 10](https://img.shields.io/badge/Pharo-10-informational)](https://pharo.org)

[Willow](https://github.com/ba-st/Willow) is developed using [Smalltalk](http://stephane.ducasse.free.fr/FreeBooks.html),
 providing a simple interface for your web application, no matter the front-end
 framework you choose.

The tutorials below assume you are familiar with Smalltalk code, and are using
[Pharo](http://pharo.org/) as your development environment. Willow is intended
to work alongside the [RenoirSt](https://github.com/ba-st/RenoirSt) DSL to define
the CSS of your application. Some basic knowledge of [Seaside](https://github.com/SeasideSt/Seaside)
is also recommended.

## Quick links

- [**Explore the docs**](docs/README.md)
- [Report a defect](https://github.com/ba-st/Willow/issues/new?labels=Type%3A+Defect)
- [Request a feature](https://github.com/ba-st/Willow/issues/new?labels=Type%3A+Feature)

## License

- The code is licensed under [MIT](LICENSE).
- The documentation is licensed under [CC BY-SA 4.0](http://creativecommons.org/licenses/by-sa/4.0/).

## Installation

To load the project in a Pharo image follow this [instructions](docs/how-to/how-to-load-in-pharo.md).

## Contributing

Check the [Contribution Guidelines](CONTRIBUTING.md)

## Credits

- Willow was first presented in the [Smalltalks 2013 Conference](http://fast.org.ar).
A video of the presentation can be seen [here](https://youtu.be/JezITRHCBuc?list=PLCGAAdUizzH027lLWKXh_44cGuEsay7-R).

- A follow up presentation was made in the Smalltalks 2017 Conference. The slides
  are available [here](https://www.slideshare.net/gcotelli/willow-101-82159948)
  and a video of the presentation can be seen [here](https://youtu.be/-QmvIBLDASM).

- Another follow up presentation was made in the ESUG 2018 and Smalltalks 2018
  conferences. The slides are available [here](https://www.slideshare.net/FASTPresentations/willow-the-interaction-tour-by-maxi-tabacman)
  and a video of the presentation can be seen [here](https://youtu.be/U6-JoPRcXHc)

- Work started by [Maximiliano Tabacman](https://github.com/mtabacman). Code
  improvements provided by [Gabriel Cotelli](https://github.com/gcotelli).
  Additional ideas and fixes by [Francisco Ortiz Peñaloza](https://github.com/fortizpenaloza)
  and [Julián Maestri](https://github.com/serpi90).

- Real world scenarios and coding time granted by [Mercap Software](https://www.mercapsoftware.com/en/).
